StacKings = LibStub("AceAddon-3.0"):NewAddon("StacKings", "AceEvent-3.0", "AceConsole-3.0")
local StacKings = _G.StacKings

function StacKings:OnInitialize()
	self:InitializeDB()
	self:InitOptions()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function StacKings:OnEnable()
	self:UpdateAllBars()
end

function StacKings:PLAYER_ENTERING_WORLD()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:InitializeBars()
end

--[===[@debug@
local DevTools_Dump
DevTools_Dump = function(value)
	LoadAddOn("Blizzard_DebugTools")
	DevTools_Dump = _G.DevTools_Dump
	DevTools_Dump(value)
end

function dump(value)
	local orig = DEFAULT_CHAT_FRAME
	DEFAULT_CHAT_FRAME = ChatFrame4
	DevTools_Dump(value)
	DEFAULT_CHAT_FRAME = orig
end

local function mystrjoin(arg1, ...)
	local text = tostring(arg1)
	for i = 1, select('#', ...) do
		text = text .. tostring(select(i, ...))
	end
	return text
end
--@end-debug@]===]

local function debug(arg1, ...)
	--[===[@debug@
	if type(arg1) == 'table' then
		dump(arg1)
	else
		local text = mystrjoin(arg1, ...)
		ChatFrame4:AddMessage(text)
	end
	--@end-debug@]===]
end
StacKings.debug = debug
